Loading...
Searching...
No Matches
pcl::ShadowPoints< PointT, NormalT > Class Template Reference
Module filters

ShadowPoints removes the ghost points appearing on edge discontinuties More...

`#include <pcl/filters/shadowpoints.h>`

Inheritance diagram for pcl::ShadowPoints< PointT, NormalT >:

## Public Types

using | Ptr = shared_ptr< ShadowPoints<PointT, NormalT> >
using | ConstPtr = shared_ptr< const ShadowPoints<PointT, NormalT> >
Public Types inherited from pcl::FilterIndices< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | Ptr = shared_ptr<FilterIndices<PointT> >
using | ConstPtr = shared_ptr<const FilterIndices<PointT> >
Public Types inherited from pcl::Filter< PointT >
using | Ptr = shared_ptr<Filter<PointT> >
using | ConstPtr = shared_ptr<const Filter<PointT> >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
Public Types inherited from pcl::PCLBase< PointT >
using | PointCloud = pcl::PointCloud<PointT>
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| ShadowPoints (bool extract_removed_indices=false)
| Empty constructor.
void | setNormals (const NormalsPtr &normals)
| Set the normals computed on the input point cloud.
NormalsPtr | getNormals () const
| Get the normals computed on the input point cloud.
void | setThreshold (float threshold)
| Set the threshold for shadow points rejection.
float | getThreshold () const
| Get the threshold for shadow points rejection.
Public Member Functions inherited from pcl::FilterIndices< PointT >
| FilterIndices (bool extract_removed_indices=false)
| Constructor.
void | filter (Indices &indices)
| Calls the filtering method and returns the filtered point cloud indices.
void | setNegative (bool negative)
| Set whether the regular conditions for points filtering should apply, or the inverted conditions.
bool | getNegative () const
| Get whether the regular conditions for points filtering should apply, or the inverted conditions.
void | setKeepOrganized (bool keep_organized)
| Set whether the filtered points should be kept and set to the value given through setUserFilterValue (default: NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
bool | getKeepOrganized () const
| Get whether the filtered points should be kept and set to the value given through setUserFilterValue (default = NaN), or removed from the PointCloud, thus potentially breaking its organized structure.
void | setUserFilterValue (float value)
| Provide a value that the filtered points should be set to instead of removing them.
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor.
IndicesConstPtr const | getRemovedIndices () const
| Get the point indices being removed.
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed.
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output.
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | applyFilter (PointCloud &output) override
| Sample of point indices into a separate PointCloud.
void | applyFilter (Indices &indices) override
| Sample of point indices.
Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class.
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Protected Attributes

NormalsPtr | input_normals_
| The normals computed at each point in the input cloud.
Protected Attributes inherited from pcl::FilterIndices< PointT >
bool | negative_ {false}
| False = normal filter behavior (default), true = inverted behavior.
bool | keep_organized_ {false}
| False = remove points (default), true = redefine points, keep structure.
float | user_filter_value_
| The user given value that the filtered point dimensions should be set to (default = NaN).
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed.
std::string | filter_name_
| The filter name.
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points.
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointT, typename NormalT>
class pcl::ShadowPoints< PointT, NormalT >

ShadowPoints removes the ghost points appearing on edge discontinuties

Author
  Aravindhan K Krishnan. This code is ported from libpointmatcher (https://github.com/ethz-asl/libpointmatcher)

Definition at line 50 of file shadowpoints.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointT, typename NormalT>

using pcl::ShadowPoints< PointT, NormalT >::ConstPtr = shared_ptr< const ShadowPoints<PointT, NormalT> >

Definition at line 70 of file shadowpoints.h.

## Ptr

template<typename PointT, typename NormalT>

using pcl::ShadowPoints< PointT, NormalT >::Ptr = shared_ptr< ShadowPoints<PointT, NormalT> >

Definition at line 69 of file shadowpoints.h.

## Constructor & Destructor Documentation

## ShadowPoints()

template<typename PointT, typename NormalT>

pcl::ShadowPoints< PointT, NormalT >::ShadowPoints | ( | bool | extract_removed_indices = false | ) |

inline

Empty constructor.

Definition at line 73 of file shadowpoints.h.

References pcl::Filter< PointT >::filter_name_, pcl::FilterIndices< PointT >::FilterIndices(), and input_normals_.

## Member Function Documentation

## applyFilter() [1/2]

template<typename PointT, typename NormalT>

void pcl::ShadowPoints< PointT, NormalT >::applyFilter | ( | Indices & | indices | ) |

override protected virtual

Sample of point indices.

Parameters

  [out] | indices | the resultant point cloud indices

Implements pcl::FilterIndices< PointT >.

Definition at line 86 of file shadowpoints.hpp.

References pcl::Filter< PointT >::extract_removed_indices_, pcl::PCLBase< PointT >::indices_, pcl::PCLBase< PointT >::input_, input_normals_, pcl::FilterIndices< PointT >::negative_, and pcl::Filter< PointT >::removed_indices_.

## applyFilter() [2/2]

template<typename PointT, typename NormalT>

void pcl::ShadowPoints< PointT, NormalT >::applyFilter | ( | PointCloud & | output | ) |

override protected virtual

Sample of point indices into a separate PointCloud.

Parameters

  [out] | output | the resultant point cloud

Reimplemented from pcl::FilterIndices< PointT >.

Definition at line 47 of file shadowpoints.hpp.

References pcl::Filter< PointT >::extract_removed_indices_, pcl::PCLBase< PointT >::input_, input_normals_, pcl::FilterIndices< PointT >::keep_organized_, pcl::FilterIndices< PointT >::negative_, pcl::Filter< PointT >::removed_indices_, and pcl::FilterIndices< PointT >::user_filter_value_.

## getNormals()

template<typename PointT, typename NormalT>

NormalsPtr pcl::ShadowPoints< PointT, NormalT >::getNormals | ( |  | ) | const

inline

Get the normals computed on the input point cloud.

Definition at line 88 of file shadowpoints.h.

References input_normals_.

## getThreshold()

template<typename PointT, typename NormalT>

float pcl::ShadowPoints< PointT, NormalT >::getThreshold | ( |  | ) | const

inline

Get the threshold for shadow points rejection.

Definition at line 98 of file shadowpoints.h.

## setNormals()

template<typename PointT, typename NormalT>

void pcl::ShadowPoints< PointT, NormalT >::setNormals | ( | const NormalsPtr & | normals | ) |

inline

Set the normals computed on the input point cloud.

Parameters

  [in] | normals | the normals computed for the input cloud

Definition at line 84 of file shadowpoints.h.

References input_normals_.

## setThreshold()

template<typename PointT, typename NormalT>

void pcl::ShadowPoints< PointT, NormalT >::setThreshold | ( | float | threshold | ) |

inline

Set the threshold for shadow points rejection.

Parameters

  [in] | threshold | the threshold

Definition at line 94 of file shadowpoints.h.

## Member Data Documentation

## input_normals_

template<typename PointT, typename NormalT>

NormalsPtr pcl::ShadowPoints< PointT, NormalT >::input_normals_

protected

The normals computed at each point in the input cloud.

Definition at line 103 of file shadowpoints.h.

Referenced by applyFilter(), applyFilter(), getNormals(), setNormals(), and ShadowPoints().

The documentation for this class was generated from the following files:

- pcl/filters/shadowpoints.h
- pcl/filters/impl/shadowpoints.hpp